<?php
/**
*
*
* @package jQuery [img] Upload v.0.0.2 / (c) 4seven / 2011
* @version $Id: uploadify_files_sig.php 2011-05-02Z 01:22 4seven $
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
**/

define('IN_PHPBB', true);
$phpbb_root_path = '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

$user->session_begin();
$auth->acl($user->data);
$user->setup();

if(check_upl_right() !== true){
trigger_error('ACCESS DENIED');
return false;}

page_header('JQuery [img] Upload');

$var_sleep  = request_var('res', '');
if ($var_sleep == 'true'){
sleep(1);}

if(check_adm_right() == true){
$request_user_it = request_var('user_its', 0);
if (!empty($request_user_it)){
$user->data['user_id'] = request_var('user_its', 0);}}

function natrsort(&$array)
{
    natsort($array);
    $array = array_reverse($array);
}

function formatBytes($bytes, $precision = 2) {
    $units = array('B', 'KB', 'MB', 'GB', 'TB');
  
    $bytes = max($bytes, 0);
    $pow = floor(($bytes ? log($bytes) : 0) / log(1024));
    $pow = min($pow, count($units) - 1);
  
    $bytes /= pow(1024, $pow);
  
    return round($bytes, $precision) . ' ' . $units[$pow];
} 

if(isset($request_user_it)){

	$sql = 'SELECT username
			FROM ' . USERS_TABLE . '
			WHERE user_id = ' . (int) $user->data['user_id'];
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

}

$template->assign_vars(array(
'USER_ID'      => $user->data['user_id'],
'USER_NAME'    => (isset($request_user_it)) ? $row['username'] : ''
));

$var_dates_1  = request_var('date', '', true);

if(!empty($var_dates_1) && ($var_dates_1 !== $user->lang['UPL_FIL_BY_DT_CLICK'])){


$template->assign_var('VAR_DATE', $var_dates_1);

$var_dates_2 = explode("/", $var_dates_1);

$dob1 = strtotime($var_dates_2[2] . '-' . $var_dates_2[0] . '-' . $var_dates_2[1]);
$dob1 = str_replace(', 00:00', '', date($user->data['user_dateformat'], $dob1));

$template->assign_var('VAR_DATE_SHOW', $dob1);

$var_dates_3 = substr($var_dates_2[2], 2) . '_' . $var_dates_2[0] . '_' . $var_dates_2[1];}

else{
$var_dates_3 = date('y_m_d');}

$http            = $config['server_protocol'];
$domain          = $config['server_name'];
$script_path     = $config['script_path'] . '/';

$img_path        = 'uploads/img/' . $user->data['user_id'] . '/' . $var_dates_3 . '/';

$img_tag_open    = '[img]';
$img_path_output = $http . $domain . $script_path . $img_path;
$img_tag_close   = '[/img]';

$handle_dir      = $phpbb_root_path . 'uploads/img/' . $user->data['user_id']. '/' . $var_dates_3;
$handle_list_dir = $phpbb_root_path . 'uploads/img/' . $user->data['user_id'] . '/' . $var_dates_3 . '/';

if (is_dir($handle_dir)){

$handle = opendir($handle_list_dir);
$data = array();

while ($file = readdir($handle)){
if($file != "." && $file != ".." 
&& $file != ".htaccess" 
&& $file != "index.php"
&& $file != "sekuro.png") {

$data[$file] = @filemtime($handle_list_dir.$file);}}
closedir($handle);
natrsort($data);

if(isset($data) && !empty($data)){

$template->assign_vars(array(
'DATE_TRUE'  => true,
'TAG_OPEN'   => $img_tag_open,
'TAG_OUTPUT' => $img_path_output,
'TAG_CLOSE'  => $img_tag_close
));

foreach ($data as $value => $key){

$sizes = @getimagesize($handle_list_dir . $value);

$template->assign_block_vars('user_img', array(
	        'USER_IMG_KEY'        => @md5_file($handle_list_dir . $value),
	        'USER_IMG_VALUE'      => $value,
	        'USER_IMG_VALUE_TEXT' => str_replace('resized_', '<strong style="color:darkgreen;">resized_</strong>', $value),			
			'USER_IMG_DATE'       => date($user->data['user_dateformat'], $key), 
			'USER_IMG_SIZE'       => @formatBytes((filesize($handle_list_dir . $value)), 2), 
			'USER_IMG_WIDTH'      => isset($sizes) ? $sizes[0] : 0,
			'USER_IMG_HEIGHT'     => isset($sizes) ? $sizes[1] : 0
			
));

// $date_user_data[] = date($user->data['user_dateformat'], $key);

}

// $template->assign_var('VAR_DATE_DATA', $date_user_data[0]);

}}

$date_path = glob($phpbb_root_path . 'uploads/img/' . $user->data['user_id'] . '/*', GLOB_ONLYDIR); 

if(!empty($date_path)){

natrsort($date_path);

foreach($date_path as $date_files){

$count_pics = count(glob($date_files . '/*')) - 2;

$date_files = str_replace($phpbb_root_path . 'uploads/img/' . $user->data['user_id'] . '/', '', $date_files);

$date_files = explode('_', $date_files);

$date_1 = $date_files[0];
$date_2 = $date_files[1];
$date_3 = $date_files[2];

$dob1 = strtotime('20' . $date_1 . '-' . $date_2 . '-' . $date_3);
$dob1 = str_replace(', 00:00', '', date($user->data['user_dateformat'], $dob1));


$template->assign_block_vars('date_nfo', array(
	        'DATE_NFO_CNT'    => $count_pics,
	        'DATE_NFO_FLS'    => ($count_pics <= 1) ? $user->lang['UPL_FIL_BY_DT_FILE'] : $user->lang['UPL_FIL_BY_DT_FILES'],			
	        'DATE_NFO_VAL'    => $date_2 . '/' . $date_3 . '/20' . $date_1,
			'DATE_NFO_SHOW'   => $dob1
			));
}
}

$template->set_filenames(array(
    'body' => 'uploadify_files_sig.html',
));

page_footer();

?>